"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Card;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CardContent = _interopRequireDefault(require("./CardContent"));

var _CardFooter = _interopRequireDefault(require("./CardFooter"));

var _CardFooterItem = _interopRequireDefault(require("./CardFooterItem"));

var _CardHeader = _interopRequireDefault(require("./CardHeader"));

var _CardHeaderIcon = _interopRequireDefault(require("./CardHeaderIcon"));

var _CardHeaderTitle = _interopRequireDefault(require("./CardHeaderTitle"));

var _CardImage = _interopRequireDefault(require("./CardImage"));

var _excluded = ["children", "className", "component"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Card(_ref) {
  var children = _ref.children,
      className = _ref.className,
      component = _ref.component,
      props = _objectWithoutProperties(_ref, _excluded);

  var Element = component;
  var classes = (0, _classnames["default"])('card', className);
  return /*#__PURE__*/_react["default"].createElement(Element, _extends({
    className: classes
  }, props), children);
}

Card.Content = _CardContent["default"];
Card.Footer = _CardFooter["default"];
Card.FooterItem = _CardFooterItem["default"];
Card.Header = _CardHeader["default"];
Card.HeaderIcon = _CardHeaderIcon["default"];
Card.HeaderTitle = _CardHeaderTitle["default"];
Card.Image = _CardImage["default"];
Card.propTypes = {
  className: _propTypes["default"].string,
  children: _propTypes["default"].node,
  component: _propTypes["default"].elementType
};
Card.defaultProps = {
  className: undefined,
  children: null,
  component: 'div'
};