"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Level;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _LevelLeft = _interopRequireDefault(require("./LevelLeft"));

var _LevelRight = _interopRequireDefault(require("./LevelRight"));

var _LevelItem = _interopRequireDefault(require("./LevelItem"));

var _excluded = ["children", "className", "component", "mobile"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Level(_ref) {
  var children = _ref.children,
      className = _ref.className,
      component = _ref.component,
      mobile = _ref.mobile,
      props = _objectWithoutProperties(_ref, _excluded);

  var Element = component;
  var classes = (0, _classnames["default"])('level', className, {
    'is-mobile': mobile
  });
  return /*#__PURE__*/_react["default"].createElement(Element, _extends({
    className: classes
  }, props), children);
}

Level.Left = _LevelLeft["default"];
Level.Right = _LevelRight["default"];
Level.Item = _LevelItem["default"];
Level.propTypes = {
  className: _propTypes["default"].string,
  children: _propTypes["default"].node,
  component: _propTypes["default"].elementType,
  mobile: _propTypes["default"].bool
};
Level.defaultProps = {
  className: undefined,
  children: null,
  component: 'nav',
  mobile: false
};